/***************************************************************************
 *                                                                         *
 *  Demo fr das EA KIT240-7                                               *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <math.h>

#define ESC   27
#define NUL    0
#define CR    13
#define LF    10
#define FF    12
#define OFF    0
#define ON     1
#define XMAX 239
#define YMAX 127


FILE *lcd;

/*--------------------------------------------------------------------------
  Routinen zur Ansteuerung des Displays definieren
 ---------------------------------------------------------------------------*/

void clr_lcd()
{ fprintf(lcd, "%c", FF);
}

void cursor(int status)
{ fprintf(lcd, "%c%c%c%c", ESC, 'Q', 'C', status);
}

void font(int fontnr, int xzoom, int yzoom)
{ fprintf(lcd, "%c%c%c%c%c", ESC, 'F', fontnr, xzoom, yzoom);
}

void rahmen(int x1, int y1, int x2, int y2)
{ fprintf(lcd, "%c%c%c%c%c%c%c", ESC, 'R', 'R', x1, y1, x2, y2);
}

void def_bar(int nr, int x1, int y1, int x2, int y2, int aw, int ew, int mst)
{ fprintf(lcd, "%c%c%c%c%c%c%c%c%c%c%c", ESC, 'B', 'O', nr, x1, y1, x2, y2, aw, ew, mst);
}

void bar(int nr, int wert)
{ fprintf(lcd, "%c%c%c%c", ESC, 'B', nr, wert);
}

void string_out(int x, int y, char *str)
{ fprintf(lcd, "%c%c%c%c%c", ESC, 'Z', 'L', x, y);
  while(*str != NUL)
     fputc(*str++, lcd);
  fputc(NUL, lcd);
}

/*--------------------------------------------------------------------------
  Hauptprogramm
 ---------------------------------------------------------------------------*/

int main()
{
  int barnr, barwert, winkel, x;

  lcd = stdaux;

  puts("\n****************************************************************");
  puts(  "*  Darstellung von 16 Bargraphs auf dem Display als Sinuswelle *");
  puts(  "*  Anschluss an COM1:                                          *");
  puts(  "*  COM1 mu zuvor initialisiert werden (MODE COM1:9600,N,8,2)  *");
  puts(  "****************************************************************");

  clr_lcd();                                     /* Display lschen */
  cursor(OFF);                                   /* Cursor unsichtbar */
  rahmen(0, 0, XMAX, YMAX);                      /* Rechteck zeichnen */
  font(5,2,2);                                   /* Zeichensatz 8x16 */
  string_out(15, 1, "BARGRAPH DEMO");             /* Zeichenkette ausgeben */

  for(barnr=1; barnr<=16; barnr++)               /* 16 Bar's definieren */
   { x = (barnr - 1)*14 + 9;
     def_bar(barnr, x, 36, x+10, 126, 0, 100, 1);
   }

  puts("\nAbbruch durch Tastendruck");

  winkel = 0;                                    /* Sinuswelle darstellen */
  while(! kbhit())
   { for(barnr = 1; barnr <= 16; barnr++)
      { barwert = 46.0 * (sin((winkel + barnr*15)*3.14/180.0) + 1.0) + 8;
	bar(17 - barnr, barwert);                     /* Einen Bargraph zeichnen */
      }
     winkel += 10;
     if(winkel >= 360)
	winkel = 0;
   }
}

